/***********************************************************************************

 Hier ist ein Beispiel für die wesentlichen Teile einer Lösung:

 class Node {
 ...

 private Node(String elem, Node next) {
 this.elem = elem;
 this.next = next;
 }

 private Node copy() {
 return new Node(elem, next == null ? null : next.copy());
 }

 public String toString() {
 if (next != null) {
 return next + " " + elem;
 }
 return elem;
 }

 }

 ...

 public void insert(String elem) {
 if (head == null) {
 head = new Node(elem, null);
 }
 else {
 Node node = head;
 while (node.next != null) {
 node = node.next;
 }
 node.next = new Node(elem, null);
 }
 }

 public String remove() {
 if (head == null) {
 return null;
 }
 String result = head.elem;
 head = head.next;
 return result;
 }

 public String get(int n) {
 if (n < 0 || head == null) {
 return null;
 }
 Node node = head;
 while (--n >= 0) {
 node = node.next;
 if (node == null) {
 return null;
 }
 }
 return node.elem;
 }

 public List copy() {
 List result = new List();
 if (this.head != null) {
 result.head = this.head.copy();
 }
 return result;
 }

 @Override
 public String toString() {
 if (head == null) {
 return "";
 }
 return head.toString();
 }

 public static void main(String[] args) {
 List list1 = new List();
 list1.insert("d");
 list1.insert("c");
 list1.insert("b");
 list1.insert("a");
 System.out.println(list1);
 System.out.println(list1.remove());
 System.out.println(list1);
 List list2 = list1.copy();
 System.out.println(list1.get(2));
 System.out.println(list2.get(3));
 }

 ***********************************************************************************/
import com.sun.xml.internal.ws.util.xml.NodeListIterator;

import java.util.Iterator;
import java.util.ListIterator;

/*
Lesen Sie die Aufgaben genau durch.
Verändern Sie die in den Aufgaben beschriebenen Programmstellen.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!

Achtung: Vorgegebene Testfälle überprüfen nur die Syntax. Sie überprüfen nicht die Korrektheit der Lösungen.
*/
public class List {

    /*
    Aufgabe:
        Objekte der Klasse List stellen verkettete Listen von Strings mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile entsprechend den Kommentaren an den mit TODO: gekennzeichneten Stellen.

    Punkte (maximal 30):
        5 Punkte für insert,
        5 Punkte für remove,
        5 Punkte für get;
        5 Punkte für copy;
        5 Punkte für toString,
        5 Punkte für main.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    class Node {

        // Do not change the object variables.  Do not add further object variables.
        private String elem;
        private Node next;

        // TODO: Define here constructors and methods of Node (if needed).

    } // End of the definition of Node


    // Initially the list is empty.
    private Node head = null;


    // Adds a string as last element to the list.
    public void insert(String elem) {
        // TODO: Implementation is your task

    }


    // Removes and returns the element in the head of the list;  the result is null if the list is empty;
    // 'insert' and 'remove' together show FIFO behavior.
    public String remove() {
        // TODO: Implementation is your task

        return null;
    }


    // Returns the n-th element of the list;  if n == 0, the element in the head of the list is returned;
    // null is returned if n < 0 or the list does not have enough elements;  'this' remains unchanged.
    public String get(int n) {
        // TODO: Implementation is your task

        return null;
    }


    // Returns a new list containing the same elements as 'this' in the same order;  'this' remains unchanged.
    // Do not use clone().
    public List copy() {
        // TODO: Implementation is your task

        return null;
    }


    // Returns a string containing the elements (separated by the space character ' ') in reverse order;
    // for example, if the list contains "x" (as first element), "y" and "z" (as last element), then toString()
    // returns "z y x";  for an empty list the result is the empty string "".
    @Override
    public String toString() {
        // TODO: Implementation is your task

        return null;
    }


    // TODO: Complete main as in the TODO comments.
    public static void main(String[] args) {
        List list1 = new List();

        // TODO: Call 'insert' 4 times such that ...

        System.out.println(list1);  // TODO: ... this statement prints: "a b c d"

        // TODO: Call 'remove' on 'list1' and print a line with the result.

        // TODO: Print another line with the content of 'list1'.

        // TODO: Create a new list 'list2' by calling 'copy' on 'list1'.

        // TODO: Call 'get(2)' on 'list1' and print a line with the result.

        // TODO: Call 'get(3)' on 'list2' and print a line with the result.

    }

}

